diff -Naru ../ppp-2.4.5/pppd/auth.c ./pppd/auth.c
--- ../ppp-2.4.5/pppd/auth.c	2019-01-11 00:16:02.136277886 +0100
+++ ./pppd/auth.c	2019-01-11 00:19:50.864772852 +0100
@@ -248,6 +248,7 @@
 bool explicit_passwd = 0;	/* Set if "password" option supplied */
 char remote_name[MAXNAMELEN];	/* Peer's name for authentication */
 bool explicit_myip = 0;
+bool explicit_peerip = 0;
 #ifdef USE_EAPTLS
 char *cacert_file  = NULL;	/* CA certificate file (pem format) */
 char *cert_file    = NULL;	/* client certificate file (pem format) */
@@ -398,6 +399,9 @@
     { "myip", o_string, myip,
       "Set server ip", OPT_PRIO | OPT_STATIC,
       &explicit_myip, MAXNAMELEN },
+   { "peerip", o_string, peerip,
+      "Set peer ip", OPT_PRIO | OPT_STATIC,
+      &explicit_peerip, MAXNAMELEN },
 
     { "password", o_string, passwd,
       "Password for authenticating us to the peer",
diff -Naru ../ppp-2.4.5/pppd/options.c ./pppd/options.c
--- ../ppp-2.4.5/pppd/options.c	2019-01-11 00:16:02.136277886 +0100
+++ ./pppd/options.c	2019-01-11 00:20:35.231674889 +0100
@@ -111,6 +111,7 @@
 int	maxfail = 10;		/* max # of unsuccessful connection attempts */
 char	linkname[MAXPATHLEN];	/* logical name for link */
 char	myip[MAXNAMELEN];	/* my ip address */
+char	peerip[MAXNAMELEN];	/* peer ip address */
 bool	tune_kernel;		/* may alter kernel settings */
 int	connect_delay = 1000;	/* wait this many ms after connect script */
 int	req_unit = -1;		/* requested interface unit */
@@ -258,6 +259,9 @@
     { "myip", o_string, myip,
      "Set my IP address",
       OPT_PRIO | OPT_PRIV | OPT_STATIC, NULL, MAXNAMELEN},
+    { "peerip", o_string, peerip,
+      "Set peer IP address",
+      OPT_PRIO | OPT_PRIV | OPT_STATIC, NULL, MAXNAMELEN},
 
     { "linkname", o_string, linkname,
       "Set logical name for link",
diff -Naru ../ppp-2.4.5/pppd/plugins/radius/radius.c ./pppd/plugins/radius/radius.c
--- ../ppp-2.4.5/pppd/plugins/radius/radius.c	2009-11-16 23:26:07.000000000 +0100
+++ ./pppd/plugins/radius/radius.c	2019-01-11 00:21:27.572559320 +0100
@@ -847,6 +847,7 @@
     VALUE_PAIR *send = NULL;
     ipcp_options *ho = &ipcp_hisoptions[0];
     u_int32_t hisaddr;
+    in_addr_t peeraddr;
 
     if (!rstate.initialized) {
 	return;
@@ -891,6 +892,10 @@
     av_type = htonl(hisaddr);
     rc_avpair_add(&send, PW_FRAMED_IP_ADDRESS , &av_type , 0, VENDOR_NONE);
 
+    peeraddr = inet_addr(peerip);
+    av_type = htonl(peeraddr);
+    rc_avpair_add(&send, PW_LOGIN_IP_HOST , &av_type , 0, VENDOR_NONE);
+
     /* Add user specified vp's */
     if (rstate.avp)
 	rc_avpair_insert(&send, NULL, rc_avpair_copy(rstate.avp));
diff -Naru ../ppp-2.4.5/pppd/pppd.h ./pppd/pppd.h
--- ../ppp-2.4.5/pppd/pppd.h	2019-01-11 00:16:02.137277884 +0100
+++ ./pppd/pppd.h	2019-01-11 00:21:51.715506013 +0100
@@ -310,6 +310,7 @@
 extern int	maxfail;	/* Max # of unsuccessful connection attempts */
 extern char	linkname[MAXPATHLEN]; /* logical name for link */
 extern char     myip[MAXNAMELEN];
+extern char     peerip[MAXNAMELEN];
 extern bool	tune_kernel;	/* May alter kernel settings as necessary */
 extern int	connect_delay;	/* Time to delay after connect script */
 extern int	max_data_rate;	/* max bytes/sec through charshunt */
